/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION

#include "obb_tree_node.h"
#include "list.h"
#include "obb.h"

using namespace std;


/**
   \brief standard constructor
*/
OBBTreeNode::OBBTreeNode () 
{
   this->setClassID(CL_OBB_TREE_NODE, "OBBTreeNode"); 

}


/**
   \brief standard deconstructor

*/
OBBTreeNode::~OBBTreeNode () 
{
  // delete what has to be deleted here
}



/**
   \brief creates a new BVTree or BVTree partition
   \param depth: the depth of the tree
   \param verticesList: the list of vertices of the object - each vertices triple is interpreted as a triangle
*/
void OBBTreeNode::spawnBVTree(const int depth, tList<sVec3D> *verticesList)
{
  float     area[verticesList->getSize()];           //!< surface area of the i'th triangle of the convex hull
  float     areaTotal;                               //!< surface area of the entire convex hull
  float     centroid[verticesList->getSize()];       //!< centroid of the i'th convex hull  
  OBB*      obb = new OBB();                         //!< the new obb to add

  /* fist compute all the convex hull particles */
  for(int i = 0; i < verticesList->getSize(); ++i)
    {
      
    }
}


void OBBTreeNode::collideWith(const BVTree &tree)
{}


void OBBTreeNode::drawBV(int currentDepth, const int depth) const
{}


void OBBTreeNode::drawBVPolygon(int currentDepth, const int depth) const
{}


void OBBTreeNode::drawBVBlended(int currentDepth, const int depth) const
{}
